<template>
    <div>
        <Base activeIndex="4">
        </Base>
        <div class="container">
            <el-row class="header">
                <el-col>
                    权限列表
                </el-col>
            </el-row>
            <el-row>
                <el-card class="box-card">
                    <!-- <template> -->
                    <el-button @click="getTable" type="primary">更新权限列表</el-button>
                    
                    <div class="common-layout">
                        <el-container>
                            <el-header>

                            </el-header>
                            <el-main>
                                <el-table ref="tableRef" row-key="no" :data="ruleForm.tableData" style="width: 100%">

                                    <el-table-column prop="no" label="学号" width="240" />
                                    <el-table-column prop="username" label="姓名" width="240" />
                                    <el-table-column prop="college_name" label="学院" width="280" />
                                    <!-- <el-table-column prop="major" label="专业" width="280" /> -->
                                    <el-table-column prop="author" label="权限" width="240" :filters="[
                                        { text: '管理员', value: '管理员' },
                                        { text: '辅导员', value: '辅导员' },
                                        { text: '临时辅导员', value: '临时辅导员' },
                                        { text: '普通用户', value: '普通用户' },
                                    ]" :filter-method="filterTag" filter-placement="bottom-end">
                                        <template #default="scope">
                                            <el-tag :type="scope.row.author === '管理员' ? 'success' :
                                        (scope.row.author === '辅导员' ? 'warning' :
                                            (scope.row.author === '临时辅导员' ? 'primary' : 'info'))" disable-transitions>
                                                {{
                                                        scope.row.author
                                                }}</el-tag>
                                        </template>
                                    </el-table-column>
                                    <el-table-column label="修改权限">
                                        <template #default="scope">
                                            <el-button size="small" :type="scope.row.author === '管理员' ? '' : 'primary'"
                                                :disabled="scope.row.author === '管理员'"
                                                @click="handleEdit(scope.$index, scope.row)">修改
                                            </el-button>
                                        </template>
                                    </el-table-column>
                                </el-table>
                            </el-main>
                        </el-container>
                    </div>
                </el-card>
            </el-row>
        </div>

    </div>

</template>

<script lang="ts">
import axios from "axios";
import Base from "./Base.vue";
import global from "./Common.vue";

import type { FormInstance, FormRules } from 'element-plus';
import { reactive, ref } from 'vue';
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
    num: "",
    code: "",
    msg: "",
    notices: [],
    tableData: [],
});



axios.defaults.withCredentials = true;
export default {
    username: "PermissionList",
    data() {
        return {
            addAuthorityVisible: false,
        }
    },

    components: {
        Base
    },
    methods: {

    }

}
</script>

<script lang="ts" setup>
import { ref, onMounted } from 'vue'
import type { TableColumnCtx } from 'element-plus/es/components/table/src/table-column/defaults'
import type { ElTable } from 'element-plus'

interface User {
    username: string
    no: string
    author: string,
    college_name: string,
    id: string
}

const tableRef = ref<InstanceType<typeof ElTable>>()

const formatter = (row: User, column: TableColumnCtx<User>) => {
    return row.no
}
const filterTag = (value: string, row: User) => {
    return row.author === value
}

const handleEdit = (index: number, row: User) => {
    console.log(row.author)
    window.location.replace("http://" + global.ip_front + "/change_permission" + "?id=" +
        row.id + "&name=" + row.username + "&academy=" + row.college_name +
        "&major=" + row.major + "&permission=" + row.author );
}
const getTable = async () => {
    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/alluser",
        data: {
            data: ruleForm.tableData,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        ruleForm.tableData = res.data.data;
        console.log(ruleForm.tableData);
    })
}

const addAuthority = async () => {
    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/alluser",
        data: {
            data: ruleForm.tableData,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        ruleForm.tableData = res.data.data;
        console.log(ruleForm.tableData);
    })
}


const deleteAuthority = async () => {
    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/alluser",
        data: {
            data: ruleForm.tableData,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        ruleForm.tableData = res.data.data;
        console.log(ruleForm.tableData);
    })
}




ruleForm.tableData = [
    {
        "author": "管理员",
        "college_name": "电子与信息工程学院",
        "no": "1953001",
        "username": "user1"
    },
    {
        "author": "辅导员",
        "college_name": "NULL",
        "no": "1953111",
        "username": "user2"
    },
    {
        "author": "临时辅导员",
        "college_name": "NULL",
        "no": "1952001",
        "username": "user3"
    },
    {
        "author": "临时辅导员",
        "college_name": "NULL",
        "no": "1954001",
        "username": "user4"
    },
    {
        "author": "普通用户",
        "college_name": "NULL",
        "no": "1955001",
        "username": "user5"
    }
]

onMounted(() => {
    getTable()
})
</script>

<style scoped>
a {
    text-decoration: none;
    color: white;
}

.container {
    position: absolute;
    width: 100%;
    height: 100%;
    background-color: rgb(238, 241, 246);
}

.box-card {
    position: relative;
    width: 75%;
    height: 80%;
    top: 70px;
    left: 200px;
    padding: 50px;
}

img {
    width: 700px;
    height: 600px;
}

.form {
    position: relative;
    top: 100px;
}

.header {
    position: relative;
    font-size: 50px;
    top: 30px;
}

.el-table .warning-row {
    --el-table-tr-bg-color: var(--el-color-warning-light-9);
}

.el-table .success-row {
    --el-table-tr-bg-color: var(--el-color-success-light-9);
}
</style>